﻿using Android.App;
using Android.Widget;
using Android.OS;
using Com.Syncfusion.Charts;
using Android.Graphics;
using Com.Syncfusion.Charts.Enums;
using Java.Util;
using System;
using System.Threading.Tasks;

namespace Chart
{
    [Activity(Label = "Chart", MainLauncher = true, Icon = "@drawable/icon")]
    public class MainActivity : Activity
    {
        private ChartObservableArrayList data1 = new ChartObservableArrayList();
        private ChartObservableArrayList data2 = new ChartObservableArrayList();
        private ChartObservableArrayList data3 = new ChartObservableArrayList();
        private ChartObservableArrayList data4 = new ChartObservableArrayList();
        private ChartObservableArrayList data5 = new ChartObservableArrayList();
        private ChartObservableArrayList data6 = new ChartObservableArrayList();
        private ChartObservableArrayList data7 = new ChartObservableArrayList();
        private ChartObservableArrayList data8 = new ChartObservableArrayList();
        private ChartObservableArrayList data9 = new ChartObservableArrayList();
        private ChartObservableArrayList data10 = new ChartObservableArrayList();

        private int wave=0;

        SfChart chart;
        System.Random random = new System.Random();
        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            LoadData();

            chart = new SfChart(this); ;
            chart.SetBackgroundColor(Color.White);
            chart.PrimaryAxis = new NumericalAxis();

            var axis = new NumericalAxis { Maximum = 100};
            chart.SecondaryAxis = axis;
            axis.LabelStyle.LabelsPosition = AxisElementPosition.Outside;
            axis.TickPosition = AxisElementPosition.Outside;

            var series1 = new FastLineSeries() { DataSource = data1 };
            var series2 = new FastLineSeries() { DataSource = data2 };
            var series3 = new FastLineSeries() { DataSource = data3 };
            var series4 = new FastLineSeries() { DataSource = data4 };
            var series5 = new FastLineSeries() { DataSource = data5 };
            var series6 = new FastLineSeries() { DataSource = data6 };
            var series7 = new FastLineSeries() { DataSource = data7 };
            var series8 = new FastLineSeries() { DataSource = data8 };
            var series9 = new FastLineSeries() { DataSource = data9 };
            var series10 = new FastLineSeries() { DataSource = data10 };

            chart.Series.Add(series1);
            chart.Series.Add(series2);
            chart.Series.Add(series3);
            chart.Series.Add(series4);
            chart.Series.Add(series5);
            chart.Series.Add(series6);
            chart.Series.Add(series7);
            chart.Series.Add(series8);
            chart.Series.Add(series9);
            chart.Series.Add(series10);


            UpdateData();

            SetContentView(chart);
        }

        private void LoadData()
        {
            for (var i = 0; i < 10; i++)
            {
                data1.AddData(i, random.Next(1, 10),false);
                data2.AddData(i, random.Next(11, 20), false);
                data3.AddData(i, random.Next(21, 30), false);
                data4.AddData(i, random.Next(31, 40), false);
                data5.AddData(i, random.Next(41, 50), false);
                data6.AddData(i, random.Next(51, 60), false);
                data7.AddData(i, random.Next(61, 70), false);
                data8.AddData(i, random.Next(71, 80), false);
                data9.AddData(i, random.Next(81, 90), false);
                data10.AddData(i, random.Next(91, 100), false);

                wave++;
            }

        }

        private async void UpdateData()
        {
            while (true)
            {
                await Task.Delay(10);
                data1.AddData(wave, random.Next(1, 10), false);
                data2.AddData(wave, random.Next(11, 20), false);
                data3.AddData(wave, random.Next(21, 30), false);
                data4.AddData(wave, random.Next(31, 40), false);
                data5.AddData(wave, random.Next(41, 50), false);
                data6.AddData(wave, random.Next(51, 60), false);
                data7.AddData(wave, random.Next(61, 70), false);
                data8.AddData(wave, random.Next(71, 80), false);
                data9.AddData(wave, random.Next(81, 90), false);
                data10.AddData(wave, random.Next(91, 100), false);

                wave++;
            }
        }

    }
}

